%define gcc_cvs     0
%define cvsdate     20030205
%define disableopt  0
%define gcc_version 3.2.2
%define gcc_release b1

#%ifarch %{ix86} alpha ia64 ppc
#%define build_ada 1
#%else
%define build_ada 0
#%endif

Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc
Version: %{gcc_version}
Release: %{gcc_release}
Copyright: GPL
Group: Development/Languages
%if %{gcc_cvs}
Source0: gcc-%{version}-%{cvsdate}.tar.bz2
%else
Source0: gcc-%{version}.tar.bz2
%endif
URL: http://gcc.gnu.org
BuildRoot: /var/tmp/gcc-root
BuildRequires: binutils >= 2.12.90.0.9-1
BuildRequires: zlib-devel, gettext, dejagnu
## up ?
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12

%if %{build_ada}
# Ada requires Ada to build
BuildRequires: gcc-gnat >= 3.1, libgnat >= 3.1
%endif

Requires: cpp = %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
Requires: binutils >= 2.12.90.0.7-1
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= %{version}-%{release}
Obsoletes: gcc3
Prereq: /sbin/install-info

#%patch

%define _gnu %{nil}


%description
The gcc package contains the GNU Compiler Collection version %{gcc_version}.
## You'll need this package in order to compile C code.

%package -n libgcc
Summary: GCC version %{gcc_version} shared support library
Group: System Environment/Libraries

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.


%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libstdc++ = %{version}
Requires: libstdc++-devel = %{version}
Obsoletes: gcc3-c++

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.


%package -n libstdc++
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Obsoletes: libstdc++3

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.


%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++ = %{version}-%{release}
Obsoletes: libstdc++3-devel

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.


%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
Obsoletes: gcc3-objc

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.


%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.


%package g77
Summary: Fortran 77 support
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libf2c = %{version}-%{release}
Prereq: /sbin/install-info
Obsoletes: gcc3-g77

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU Compiler Collection.


%package -n libf2c
Summary: Fortran 77 runtime
Group: System Environment/Libraries

%description -n libf2c
This package contains Fortran 77 shared library which is needed to run
Fortran 77 dynamically linked programs.


%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgcj >= %{version}, libgcj-devel >= %{version}
Obsoletes: gcc3-java
Prereq: /sbin/install-info

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.


%package -n libgcj
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Requires: zip >= 2.1
Obsoletes: gcc-libgcj
Obsoletes: libgcj3
# Kaffe includes jar too
Conflicts: kaffe

%description -n libgcj
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).


%package -n libgcj-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1, libgcj = %{version}
Obsoletes: libgcj3-devel

%description -n libgcj-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).


%package -n cpp
Summary: The C Preprocessor.
Group: Development/Languages
Prereq: /sbin/install-info
%ifarch ia64
Obsoletes: gnupro
%endif

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.


%package gnat
Summary: Ada 95 support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}, libgnat = %{version}-%{release}
Obsoletes: gnat-devel, gcc3-gnat
Prereq: /sbin/install-info

%description gnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes development tools,
the documents and Ada 95 compiler.

%package -n libgnat
Summary: GNU Ada 95 runtime shared libraries
Group: System Environment/Libraries
Obsoletes: gnat libgnat3

%description -n libgnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes shared libraries,
which are required to run programs compiled with the GNAT.


##
## Setup Section
##

%prep
%if %{gcc_cvs}
%setup -q -n gcc-%{version}-%{cvsdate}
%else
%setup -q -n gcc-%{version}
%endif

# Berry Linux Release
##perl -pi -e 's/3\.2\.2/3.2/' gcc/version.c gcc/f/version.c gcc/ada/gnatvsn.ads
##perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
##perl -pi -e 's/\((prerelease|experimental|release)\)/\(Berry Linux %{version}-%{gcc_release}\)/' gcc/version.c gcc/f/version.c
##perl -pi -e 's/\((prerelease|experimental|release)\)/\(%{version}-%{gcc_release}\)/' gcc/ada/gnatvsn.ads
##perl -pi -e 's/#define GCCBUGURL.*$/#define GCCBUGURL "<URL:http:\/\/yui.mine.nu\/linux\/>"/' gcc/system.h
# The version string is now longer than 32 bytes and the line containing it
# doesn't fit into 80 columns
#perl -pi -e 's/:= 32/:= 64/;s/(Gnat_Version_String.*:=)/\1\n    /' gcc/ada/gnatvsn.ads

##./contrib/gcc_update --touch


##
## Build Section
##

%build
%if %{disableopt}
export RPM_OPT_FLAGS="-O2"
%endif

rm -rf obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking --host=%{_target_platform} \
	--with-system-zlib --enable-__cxa_atexit

# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi

make -j$RPM_BUILD_NCPUS bootstrap-lean
#make -j$RPM_BUILD_NCPUS bootstrap

%if %{build_ada}
# This doesn't work with -j$RPM_BUILD_NCPUS
make -C gcc gnatlib-shared
make -C gcc gnattools
make -C gcc/ada doc
%endif

# run the tests.
make -j$RPM_BUILD_NCPUS -k check || :
%ifarch %{ix86}
ln -sf i686-pc-linux-gnu ../libstdc++-v3/config/abi/%{_target_platform}
ln -sf i686-pc-linux-gnu ../libstdc++-v3/config/abi/%{_target_platform}-gnu
%endif
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
%ifarch %{ix86}
make -C %{_target_platform}/libstdc++-v3 check-abi
%endif
echo ====================TESTING END=====================
#cd %{_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)


##
## Install Section
##

%install
rm -rf $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{_target_platform}
TARGET_PLATFORM=%{_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{_target_platform}/libstdc++-v3
make -C %{_target_platform}/libjava

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install
%if %{build_ada}
pushd gcc/ada
cp -a gnat-style.info* gnat_rm.info* $RPM_BUILD_ROOT%{_infodir}/
for i in gnat_ug_unx.info*; do
  sed 's/gnat_ug_unx/gnat_ug/g' $i > $RPM_BUILD_ROOT%{_infodir}/`echo $i | sed 's/gnat_ug_unx/gnat_ug/'`
done
chmod 644 $RPM_BUILD_ROOT%{_infodir}/gnat*
popd
%endif

FULLPATH=$(dirname $RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1)

file $RPM_BUILD_ROOT/%{_prefix}/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,cc1obj,cc1plus,cpp0,tradcpp0,f771,jc1,jvgenmain}

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
## err  gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/gnatgcc

mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.*a $FULLPATH/
sed 's/-lgcjgc//g;s/-lzgcj//g;s/-lpthread//g' $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec > $FULLPATH/libgcj.spec
mv $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f $RPM_BUILD_ROOT%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir $RPM_BUILD_ROOT%{_prefix}/include/gcj

mkdir -p $RPM_BUILD_ROOT/%{_lib}
%if %{gcc_cvs}
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{cvsdate}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{cvsdate}.so.1
ln -sf libgcc_s-%{gcc_version}-%{cvsdate}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
%else
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/
%endif

ln -sf ../../%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so
#ln -sf `echo "%{_prefix}" | sed 's~/[^/]*~\.\./~g'`../%{_lib}/libgcc_s.so.1 \
#  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so
#mv -f $FULLPATH/libobjc.so.1* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
%if %{build_ada}
mv -f $FULLPATH/adalib/libgnarl-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
mv -f $FULLPATH/adalib/libgnat-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
rm -f $FULLPATH/adalib/libgnarl.so* $FULLPATH/adalib/libgnat.so*
%endif
pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.5.* libstdc++.so
ln -sf ../../../libgcj.so.3.* libgcj.so
ln -sf ../../../libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../libgnarl-*.so.* libgnarl.so
ln -sf ../../../../libgnat-*.so.* libgnat.so
cd ..
%endif
else
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.5.* libstdc++.so
ln -sf ../../../../%{_lib}/libgcj.so.3.* libgcj.so
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../../%{_lib}/libgnarl-*.so.* libgnarl.so
ln -sf ../../../../../%{_lib}/libgnat-*.so.* libgnat.so
cd ..
%endif
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libstdc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libfrtbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a .
# Strip debug info from Fortran/ObjC/Java static libraries
strip -g libg2c.a libobjc.a libgcj.a
# Fix up .la files
for i in *.la; do
  sed -e '/^libdir/s_%{_prefix}/lib_%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}_' \
      -e '/^dependency_libs/s_%{_prefix}/lib_%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}_' \
      -e '/^dependency_libs/s~'\''$~ '\''~' \
      -e '/^dependency_libs/s~[ 	][ 	]*~ ~g' \
      -e '/^dependency_libs/s~-L[^ ]* ~~g' \
      -e '/^dependency_libs/s~-lgcc_s -lgcc -lc -lgcc_s -lgcc ~~g' \
      -e '/^dependency_libs/s~-lgcc -lc -lgcc ~~g' \
      -e '/^dependency_libs/s~-lc ~~g' \
      -e '/^dependency_libs/s~-lm \(-lm \)*~-lm ~g' \
      $i > $i.tmp
  mv -f $i.tmp $i
done
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.so.1.*
%if %{build_ada}
chmod 755 $RPM_BUILD_ROOT%{_prefix}/lib/libgnarl*so*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/lib/libgnat*so*
%endif

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

cd ..
%find_lang %{name}


%clean
rm -rf $RPM_BUILD_ROOT


##
## post & postun section
##

##%post
##/sbin/install-info \
##  --info-dir=%{_infodir} %{_infodir}/gcc.info.gz

##%preun
##if [ $1 = 0 ]; then
##  /sbin/install-info --delete \
##    --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
##fi

##%post -n cpp
##/sbin/install-info \
##  --info-dir=%{_infodir} %{_infodir}/cpp.info.gz

##%preun -n cpp
##if [ $1 = 0 ]; then
##  /sbin/install-info --delete \
##    --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
##fi

##%post g77
##/sbin/install-info \
##  --info-dir=%{_infodir} %{_infodir}/g77.info.gz

##%preun g77
##if [ $1 = 0 ]; then
##  /sbin/install-info --delete \
##    --info-dir=%{_infodir} %{_infodir}/g77.info.gz
##fi

##%post java
##/sbin/install-info \
##  --info-dir=%{_infodir} %{_infodir}/gcj.info.gz

##%preun java
##if [ $1 = 0 ]; then
##  /sbin/install-info --delete \
##    --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
##fi

##%post gnat
##/sbin/install-info \
##  --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
##/sbin/install-info \
##  --info-dir=%{_infodir} %{_infodir}/gnat_ug.info.gz

##%preun gnat
##if [ $1 = 0 ]; then
##  /sbin/install-info --delete \
##    --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
##  /sbin/install-info --delete \
##    --info-dir=%{_infodir} %{_infodir}/gnat_ug.info.gz
##fi

%post -n libgcc -p /sbin/ldconfig

%postun -n libgcc -p /sbin/ldconfig

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%post -n libobjc -p /sbin/ldconfig

%postun -n libobjc -p /sbin/ldconfig

%post -n libgcj -p /sbin/ldconfig

%postun -n libgcj -p /sbin/ldconfig

%post -n libf2c -p /sbin/ldconfig

%postun -n libf2c -p /sbin/ldconfig

%post -n libgnat -p /sbin/ldconfig

%postun -n libgnat -p /sbin/ldconfig


##
## Files Section
##

%files -f %{name}.lang
%defattr(-,root,root)
%{_prefix}/bin/cc
%{_prefix}/bin/c89
%{_prefix}/bin/c99
%{_prefix}/bin/gcc
%{_prefix}/bin/gcov
%{_prefix}/bin/protoize
%{_prefix}/bin/unprotoize
%{_prefix}/bin/%{_target_platform}-gcc
%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
##%{_infodir}/gcc*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/syslimits.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/xmmintrin.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/altivec.h
%endif
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/specs
%{_prefix}/%{_lib}/libgcc_s.so
%doc gcc/README* gcc/*ChangeLog*

%files -n cpp
%defattr(-,root,root)
/lib/cpp
%{_prefix}/bin/cpp
%{_mandir}/man1/cpp.1*
##%{_infodir}/cpp*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cpp0
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/tradcpp0

%files -n libgcc
%defattr(-,root,root)
%if %{gcc_cvs}
/%{_lib}/libgcc_s-%{gcc_version}-%{cvsdate}.so.1
%else
/%{_lib}/libgcc_s.so.1
%endif


%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{_target_platform}-*++
%{_prefix}/bin/g++
%{_prefix}/bin/c++
%{_prefix}/bin/c++filt
%{_mandir}/man1/g++.1*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%doc gcc/cp/ChangeLog*

%files -n libstdc++
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++.so.5*

%files -n libstdc++-devel
%defattr(-,root,root)
%{_prefix}/include/c++
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libstdc++.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libsupc++.a
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%files objc
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/objc
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libobjc.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libobjc.so
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

%files -n libobjc
%defattr(-,root,root)
%{_prefix}/%{_lib}/libobjc.so.1*

%files g77
%defattr(-,root,root)
%{_prefix}/bin/g77
%{_prefix}/bin/f77
%{_mandir}/man1/g77.1*
##%{_infodir}/g77*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/f771
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libg2c.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libg2c.so
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/g2c.h
%doc gcc/f/README rpm.doc/g77/*

%files -n libf2c
%defattr(-,root,root)
%{_prefix}/%{_lib}/libg2c.so.0*

%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj
%{_prefix}/bin/gcjh
%{_prefix}/bin/jcf-dump
%{_prefix}/bin/jv-scan
%{_mandir}/man1/gcj.1*
%{_mandir}/man1/gcjh.1*
%{_mandir}/man1/jcf-dump.1*
%{_mandir}/man1/jv-scan.1*
##%{_infodir}/gcj*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/jc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/jvgenmain
%doc gcc/java/ChangeLog*

%files -n libgcj
%defattr(-,root,root)
%{_prefix}/bin/jv-convert
%{_prefix}/bin/gij
%{_prefix}/bin/jar
%{_prefix}/bin/grepjar
%{_prefix}/bin/rmic
%{_prefix}/bin/rmiregistry
%{_mandir}/man1/jv-convert.1*
%{_mandir}/man1/gij.1*
%{_mandir}/man1/rmic.1*
%{_mandir}/man1/rmiregistry.1*
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/share/java
%{_prefix}/lib/security

%files -n libgcj-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.spec
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/gcj
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/org
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*

%if %{build_ada}
%files gnat
%defattr(-,root,root)
%{_prefix}/bin/gnat*
##%{_infodir}/gnat*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/adainclude
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/adalib
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/gnat1
%doc gcc/ada/ChangeLog

%files -n libgnat
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgnat-*.so.*
%{_prefix}/%{_lib}/libgnarl-*.so.*
%endif


##
## change log
##

%changelog
* Tue Feb 11 2003 Yuichiro Nakada <berry@po.yui.mine.nu>
- create for berry linux
- from Redhat Linux 8.0
